#ifndef __MCTD_LOG_H__
#define __MCTD_LOG_H__

#include <syslog.h>
#include <stdbool.h>

void syslog_open(const char *name);
void syslog_close();

void log_at_recv(const char *str);
void log_at_send(const char *str);

void log_write(int priority, const char *format, ...);
void set_output_at_command_log(bool enable);

#define log_dbg(fmt, ...)  log_write(LOG_DEBUG, "%s(%d): " fmt, __func__, __LINE__, ## __VA_ARGS__)
#define log_info(fmt, ...) log_write(LOG_INFO, "%s(%d): " fmt, __func__, __LINE__, ## __VA_ARGS__)
#define log_warn(fmt, ...) log_write(LOG_WARNING, "%s(%d): " fmt, __func__, __LINE__, ## __VA_ARGS__)
#define log_err(fmt, ...)  log_write(LOG_ERR, "%s(%d): " fmt, __func__, __LINE__, ## __VA_ARGS__)

#endif /* __MCTD_LOG_H__ */
